from __future__ import print_function
import sys
if len(sys.argv) > 1:
   sys.path.insert(0, sys.argv[1])
import hfst

types = []
if hfst.HfstTransducer.is_implementation_type_available(hfst.ImplementationType.SFST_TYPE):
   types.append(hfst.ImplementationType.SFST_TYPE)
if hfst.HfstTransducer.is_implementation_type_available(hfst.ImplementationType.TROPICAL_OPENFST_TYPE):
   types.append(hfst.ImplementationType.TROPICAL_OPENFST_TYPE)
if hfst.HfstTransducer.is_implementation_type_available(hfst.ImplementationType.FOMA_TYPE):
   types.append(hfst.ImplementationType.FOMA_TYPE)

for type in types:
   if hfst.HfstTransducer.is_implementation_type_available(type):
      hfst.set_default_fst_type(type)
      
      for test in ['four_plus_cats', 'cat2dog']:
         tr1 = hfst.compile_sfst_file(test + '.sfstpl')
         f = open(test + '.att')
         tr2 = hfst.read_att_transducer(f)
         f.close()
         if not tr1.compare(tr2):
            raise RuntimeError(test + ' failed')
